	.file	"invert-f.c"
	.version	"01.01"
gcc2_compiled.:
	.ident	"@(#)head:math.h	2.11.6.1"
	.ident	"@(#)head:malloc.h	1.7"
.text
	.align 16
.globl fast_matrix_invert
	.type	 fast_matrix_invert,@function
fast_matrix_invert:
	pushl %esi
	pushl %edi
	pushl %ebx
	pushl %ecx
	pushl %edx
	pushl %ebp
	movl 32(%esp),%esi	/ :35  v = (double *) malloc((long)n * sizeof(double));

	movl %esi,%ebp
	decl %ebp		/ NOTE: I'm assuming n > 0
	pushl %ebp		/ save n-1 for initializing loops 

	leal (,%esi,8),%eax 	/ interesting shift of a reg...
	pushl %eax
	call malloc
	addl $4,%esp
	movl 32(%esp),%edx 	/ :32  a = xa;
	movl (%esp),%ebp
		/ call malloc actually messes up edx!! (and ecx at least)
	      	/ so, I initialize all needed regs after the call.

	movl %eax,%ebx
	testl %eax,%eax		/ :36  if (!v) return(-1);
	jne .TOP_LOOP_J
	movl $-1,%eax
	addl $4,%esp		/ get rid of n-1 before leaving
	jmp .THE_END
	.align 16
.TOP_LOOP_J:
	                	/ :41  for (j=n-1;j>=0;j--) {
				/  j is in ebp (still there)
	movl %ebp,%edi		/ :44  for (k=0;k<j;k++) v[k] = 0;
	leal (,%edi,2),%ecx	/   double the count (longs --> doubles)
	movl %ebx,%edi		/   NOTE: assume j >= 0 
	movl $0,%eax		/   NOTE 2: I am assuming ES = DS ... (not safe)
	cld			/    but I think unix uses a 'flat' mem model 
	rep			/   %edi points to v[j] at end... ('empty')
	stosl

	movl (%edx,%ebp,4),%eax	/ :47  scale = 1 / a[j][j];
	fld1
	fdivl (%eax,%ebp,8)
	movl (%esp),%ecx	/ :48  for (i=n-1;i>=0;i--) a[j][i] *= scale;
.NORMALIZE:
	fld %st(0)
 	fmull (%eax,%ecx,8)
  	fstpl (%eax,%ecx,8)
	decl %ecx
	jns .NORMALIZE

	fstpl (%edi)		/ :49  v[j] =  scale;

	leal -1(%ebp),%edi	/ :52  for (i=j-1; i>=0; i--) {
	testl %edi,%edi
	jl .NO_LOOP_I
.TOP_LOOP_I:
	movl (%edx,%edi,4),%esi	/ :53  scale = a[i][j];
	fldl (%esi,%ebp,8)

	movl (%esp),%ecx	/ :54  for (k=n-1;k>=0;k--) {
.TOP_LOOP_K:
	fld %st(0)		/ :55  a[i][k] -= scale * a[j][k];
	fmull (%eax,%ecx,8)
	fsubrl (%esi,%ecx,8)
	fstpl (%esi,%ecx,8)
	decl %ecx		/ :56  }   (end of for k loop)
	jns .TOP_LOOP_K

	fmull (%ebx,%ebp,8)	/ :57  v[i] -= scale * v[j];
	fsubrl (%ebx,%edi,8)
	fstpl (%ebx,%edi,8)
	
	decl %edi		/ :58  }   (end of for i loop)
	jns .TOP_LOOP_I

.NO_LOOP_I:
	movl %ebp,%ecx 		/ :60  for (i=j;i>=0;i--) {
.COPY_OVER:
	movl (%edx,%ecx,4),%esi	/ :61  a[i][j] = v[i];
	movl (%ebx,%ecx,8),%eax
  	movl %eax,(%esi,%ebp,8)
	movl 4(%ebx,%ecx,8),%eax 	/ moving doubles using longs..
   	movl %eax,4(%esi,%ebp,8)
	decl %ecx
	jns .COPY_OVER		/ :62 }  (end of copy loop)

	decl %ebp
	jns .TOP_LOOP_J		/ :63 }  (end of j loop)

	movl $0,%ebp		/ :68  for (j=0;j<n;j++) {
.TOP_J:
	movl (%edx,%ebp,4),%eax	/   eax = a[j] for later
	leal 1(%ebp),%edi	/ :70  for (i=j+1;i<n;i++) {
	cmpl (%esp),%edi
	jg .SKIP_I
.TOP_I:
	movl (%edx,%edi,4),%esi	/ :71  scale = a[i][j];
	fldl (%esi,%ebp,8)
	movl %edi,%ecx		/ :72  for (k=i;k<n;k++) {
.TOP_K:
	fld %st(0)		/ :73  a[i][k] -= scale * a[j][k];
	fmull (%eax,%ecx,8)
	fsubrl (%esi,%ecx,8)
	fstpl (%esi,%ecx,8)
	incl %ecx		/ :74  }   (end of for k loop)
	cmpl (%esp),%ecx
	jle .TOP_K
	fstp %st(0)		/  get rid of scale

	movl (%eax,%edi,8),%ecx	/ :75  a[i][j] = a[j][i];
	movl %ecx,(%esi,%ebp,8)
	movl 4(%eax,%edi,8),%ecx	/ moving doubles using longs...
	movl %ecx,4(%esi,%ebp,8)

	incl %edi		/ :76 end of i loop
	cmpl (%esp),%edi
	jle .TOP_I

.SKIP_I:
	incl %ebp		/ :77 end of j loop
	cmpl (%esp),%ebp
	jle .TOP_J

	pushl %ebx		/ :79 free(v);
	call free

	addl $8,%esp		/ get rid of v (for last call) and n-1
.THE_END:
	popl %ebp
	popl %edx
	popl %ecx
	popl %ebx
	popl %edi
	popl %esi
	ret
.Lfe1:
	.size	 fast_matrix_invert,.Lfe1-fast_matrix_invert
	.ident	"GCC: (GNU) 2.3.1"
